<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 529     Patch: 13                                                 |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function NewsDoPoll
 * A function to write a poll result to the database
 * @author Philipp Louis Esselbach
 */
function NewsDoPoll()
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$input_newsstory_id = ( isset( $_POST[ 'input_newsstory_id' ] ) ) ? $security -> checknum( $_POST[ 'input_newsstory_id' ] ) : "" ;
	$input_vote = ( isset( $_POST[ 'input_vote' ] ) ) ? $security -> checknum( $_POST[ 'input_vote' ] ) : "" ;
	$input_votes = ( isset( $_POST[ 'input_votes' ] ) ) ? $security -> checknumarray( $_POST[ 'input_votes' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','news_story_poll_voting_header','news_story_poll_voting_done','news_story_poll_voting_footer','news_story_error_invalidrating','news_story_error_banned','news_story_error_alreadyvoted_user','news_story_error_alreadyvoted_anon','news_story_error_login'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	$error = "";
	$templates -> initgzip();
	session_start();
	
	if( ( $_SESSION[ 'news_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
		exit;
	}
	
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	$query = $database -> dbquery( "SELECT newsstory_id, newsstory_title, newsstory_seo, newsstory_status, newsstory_date, newsstory_poll FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_id = '" . $input_newsstory_id . "'" );
	
	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_status' ], $newsstory_date, $insert[ 'newsstory_poll' ] ) = $database -> dbrow( $query );
		$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
		$insert[ 'newsstory_date' ] = $system -> convertdate( $newsstory_date, $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );
		$insert[ 'newsstory_month' ] = $system -> convertdate( $newsstory_date, "%B %Y", $preferences[ 'website_timezone' ] );
		$insert[ 'newsstory_month_id' ] = $system -> getmonth( $newsstory_date );
		( $insert[ 'newsstory_poll' ] ) ? $input_poll_array = explode( "|", $insert[ 'newsstory_poll' ] ) : $input_poll_array = array();
		$input_poll_options = count( $input_poll_array ) - 2;
		$input_poll_choice = $input_poll_array[ 1 ];
		
		if( $preferences[ 'news_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'news_story_poll_voting_header_html' ], $main_templates[ 'news_story_poll_voting_header_php' ], $insert );
		}
		
		if( $user[ 'user_status' ] or $preferences[ 'news_allow_unregpolls' ] )
		{
			$uniqueid = md5( $_SERVER[ 'HTTP_USER_AGENT' ] . $ipaddr );
			
			if( is_array( $input_votes ) and count( $input_votes ) and $input_poll_choice )
			{
				for( $i = 0; $i < count( $input_votes ); $i++ )
				{
					if( $input_votes[ $i ] > $input_poll_options )
					{
						$error = $templates -> exectemplate( $main_templates[ 'news_story_error_invalidrating_html' ], $main_templates[ 'news_story_error_invalidrating_php' ], $insert );
					}
				}
			}
			else
			{
				if( !$input_vote or $input_vote > $input_poll_options )
				{
					$error = $templates -> exectemplate( $main_templates[ 'news_story_error_invalidvote_html' ], $main_templates[ 'news_story_error_invalidvote_php' ], $insert );
				}
			}
			
			if( $user[ 'user_status' ] == 5 )
			{
				$error = $templates -> exectemplate( $main_templates[ 'news_story_error_banned_html' ], $main_templates[ 'news_story_error_banned_php' ], $insert );
			}
			
			if( $user[ 'user_status' ] and !$error )
			{
				$userid = $database -> dbescape( $user[ 'user_id' ] );
				$query = $database -> dbquery( "SELECT newspoll_id FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $input_newsstory_id . "' AND newspoll_user = '" . $userid . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					$error = $templates -> exectemplate( $main_templates[ 'news_story_error_alreadyvoted_user_html' ], $main_templates[ 'news_story_error_alreadyvoted_user_php' ], $insert );
				}
			}
			else
			{
				$userid = 0;
				$query = $database -> dbquery( "SELECT newspoll_id FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $input_newsstory_id . "' AND newspoll_uniqueid = '" . $uniqueid . "'" );
				
				if( $database -> dbrows( $query ) )
				{
					$error = $templates -> exectemplate( $main_templates[ 'news_story_error_alreadyvoted_anon_html' ], $main_templates[ 'news_story_error_alreadyvoted_anon_php' ], $insert );
				}
			}
			
			if( !$error )
			{
				if( is_array( $input_votes ) )
				{
					for( $i = 0; $i < count( $input_votes ); $i++ )
					{
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newspolls (newspoll_id, newspoll_story, newspoll_user, newspoll_uniqueid, newspoll_vote, newspoll_date, newspoll_ip) VALUES (NULL, '" . $input_newsstory_id . "', '" . $userid . "', '" . $uniqueid . "', '" . $input_votes[ $i ] . "', now(), '" . $ipaddr . "')" );
					}
				}
				else
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newspolls (newspoll_id, newspoll_story, newspoll_user, newspoll_uniqueid, newspoll_vote, newspoll_date, newspoll_ip) VALUES (NULL, '" . $input_newsstory_id . "', '" . $userid . "', '" . $uniqueid . "', '" . $input_vote . "', now(), '" . $ipaddr . "')" );
				}
				
				$input_results_array = array();
				
				for( $i = 0; $i < 20; $i++ )
				{
					$input_results_array[ ] = 0;
				}
				
				$query = $database -> dbquery( "SELECT newspoll_vote FROM " . DB_PREFIX . "esselbach_ct_newspolls WHERE newspoll_story = '" . $input_newsstory_id . "'" );
				
				while( list( $newspoll_vote ) = $database -> dbrow( $query ) )
				{
					$newspoll_vote_id = $newspoll_vote - 1;
					
					if( isset( $input_results_array[ $newspoll_vote_id ] ) )
					{
						$input_results_array[ $newspoll_vote_id ] = $input_results_array[ $newspoll_vote_id ] + 1;
					}
				}
				
				$newsstory_pollresults = implode( "|", $input_results_array );
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_pollresults = '" . $newsstory_pollresults . "' WHERE newsstory_id = '" . $input_newsstory_id . "'" );
				echo $templates -> exectemplate( $main_templates[ 'news_story_poll_voting_done_html' ], $main_templates[ 'news_story_poll_voting_done_php' ], $insert );
			}
		}
	}
	else
	{
		$error = $templates -> exectemplate( $main_templates[ 'news_story_error_login_html' ], $main_templates[ 'news_story_error_login_php' ], $insert );
	}
	
	if( $error )
	{
		echo $error;
	}
	
	if( $preferences[ 'news_navigation' ] )
	{
		echo $templates -> exectemplate( $main_templates[ 'news_story_poll_voting_footer_html' ], $main_templates[ 'news_story_poll_voting_footer_php' ], $insert );
	}
	
	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>